import { escapeState } from '@taro-hooks/shared';
import { useEffect } from '@taro-hooks/core';
import { useVisible } from 'taro-hooks';
var listeners = [];
function subscribeReVisible(listener) {
  listeners.push(listener);
  var visible = useVisible();
  useEffect(function () {
    if (escapeState(visible)) {
      for (var i = 0; i < listeners.length; i++) {
        var _listener = listeners[i];
        _listener();
      }
    }
  }, [visible]);
  return function unsubscribe() {
    var index = listeners.indexOf(listener);
    listeners.splice(index, 1);
  };
}
export default subscribeReVisible;