"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var shared_1 = require("@taro-hooks/shared");
var core_1 = require("@taro-hooks/core");
var taro_hooks_1 = require("taro-hooks");
var listeners = [];
function subscribeReVisible(listener) {
  listeners.push(listener);
  var visible = (0, taro_hooks_1.useVisible)();
  (0, core_1.useEffect)(function () {
    if ((0, shared_1.escapeState)(visible)) {
      for (var i = 0; i < listeners.length; i++) {
        var _listener = listeners[i];
        _listener();
      }
    }
  }, [visible]);
  return function unsubscribe() {
    var index = listeners.indexOf(listener);
    listeners.splice(index, 1);
  };
}
exports["default"] = subscribeReVisible;